//@line 39 "/export/home/mozilla/uild/granparadiso-alpha6/src/mozilla/browser/components/shell/content/setDesktopBackground.js"

const kXUL_NS           = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
const kHTML_NS          = "http://www.w3.org/1999/xhtml";
const kIShellService    = Components.interfaces.nsIShellService;
//@line 46 "/export/home/mozilla/uild/granparadiso-alpha6/src/mozilla/browser/components/shell/content/setDesktopBackground.js"

var gSetBackground = {
  _position         : kIShellService.BACKGROUND_STRETCH,
  _monitor          : null,
  _image            : null,
  _backgroundColor  : 0,

//@line 54 "/export/home/mozilla/uild/granparadiso-alpha6/src/mozilla/browser/components/shell/content/setDesktopBackground.js"
  // Converts a color string in the format "#RRGGBB" to an integer.
  _hexStringToLong: function (aString)
  {
    return parseInt(aString.substring(1,3), 16) << 16 | 
           parseInt(aString.substring(3,5), 16) << 8 |
           parseInt(aString.substring(5,7), 16);
  },

  _rgbToHex: function(aR, aG, aB) 
  {
    var rHex = aR.toString(16).toUpperCase();
    var gHex = aG.toString(16).toUpperCase();
    var bHex = aB.toString(16).toUpperCase();

    if (rHex.length == 1) rHex ='0' + rHex;
    if (gHex.length == 1) gHex ='0' + gHex;
    if (bHex.length == 1) bHex ='0' + bHex;

    return '#' + rHex + gHex + bHex;
  },
//@line 75 "/export/home/mozilla/uild/granparadiso-alpha6/src/mozilla/browser/components/shell/content/setDesktopBackground.js"

  get _shell()
  {
    return Components.classes["@mozilla.org/browser/shell-service;1"]
                     .getService(Components.interfaces.nsIShellService);
  },

  load: function ()
  {
    this._monitor = document.getElementById("monitor");
//@line 88 "/export/home/mozilla/uild/granparadiso-alpha6/src/mozilla/browser/components/shell/content/setDesktopBackground.js"
    this.init(window.arguments[0]);
  },

  init: function (aImage)
  {
    this._image = aImage;

//@line 96 "/export/home/mozilla/uild/granparadiso-alpha6/src/mozilla/browser/components/shell/content/setDesktopBackground.js"
    this._initColor();
    var position = parseInt(document.getElementById("menuPosition").value);
//@line 112 "/export/home/mozilla/uild/granparadiso-alpha6/src/mozilla/browser/components/shell/content/setDesktopBackground.js"
    this.updatePosition(position);
  },

//@line 116 "/export/home/mozilla/uild/granparadiso-alpha6/src/mozilla/browser/components/shell/content/setDesktopBackground.js"
  _initColor: function ()
  {
    var color = this._shell.desktopBackgroundColor;

    const rMask = 4294901760;
    const gMask = 65280;
    const bMask = 255;
    var r = (color & rMask) >> 16;
    var g = (color & gMask) >> 8;
    var b = (color & bMask);
    this.updateColor(this._rgbToHex(r, g, b));

    var colorpicker = document.getElementById("desktopColor");
    colorpicker.color = this._backgroundColor;
  },
//@line 132 "/export/home/mozilla/uild/granparadiso-alpha6/src/mozilla/browser/components/shell/content/setDesktopBackground.js"

  observe: function (aSubject, aTopic, aData)
  {
    if (aTopic == "shell:desktop-background-changed") {
      var setDesktopBackground = document.getElementById("setDesktopBackground");
      setDesktopBackground.hidden = true;

      var showDesktopPreferences = document.getElementById("showDesktopPreferences");
      showDesktopPreferences.hidden = false;

      var os = Components.classes["@mozilla.org/observer-service;1"]
                         .getService(Components.interfaces.nsIObserverService);
      os.removeObserver(this, "shell:desktop-background-changed");
    }
  },

//@line 168 "/export/home/mozilla/uild/granparadiso-alpha6/src/mozilla/browser/components/shell/content/setDesktopBackground.js"
  setDesktopBackground: function () 
  {
    this._shell.setDesktopBackground(this._image, this._position);
    this._shell.desktopBackgroundColor = this._hexStringToLong(this._backgroundColor);
    document.persist("menuPosition", "value");
  },
//@line 175 "/export/home/mozilla/uild/granparadiso-alpha6/src/mozilla/browser/components/shell/content/setDesktopBackground.js"

  updateColor: function (color)
  {
//@line 179 "/export/home/mozilla/uild/granparadiso-alpha6/src/mozilla/browser/components/shell/content/setDesktopBackground.js"
    this._backgroundColor = color;
    this._monitor.style.backgroundColor = color;
//@line 182 "/export/home/mozilla/uild/granparadiso-alpha6/src/mozilla/browser/components/shell/content/setDesktopBackground.js"
  },
  
  updatePosition: function (aPosition)
  {
    if (this._monitor.hasChildNodes())
      this._monitor.removeChild(this._monitor.firstChild);
      
    this._position = aPosition;
    if (this._position == kIShellService.BACKGROUND_TILE)
      this._tileImage();
    else if (this._position == kIShellService.BACKGROUND_STRETCH)
      this._stretchImage();
    else
      this._centerImage();
  },

  _createImage: function ()
  {
    const nsIImageLoadingContent = Components.interfaces.nsIImageLoadingContent;
    if (!(this._image instanceof nsIImageLoadingContent))
        return false;

    var request = this._image.QueryInterface(nsIImageLoadingContent)
                             .getRequest(nsIImageLoadingContent.CURRENT_REQUEST);
    if (!request)
      return false;

    var imgURI = this._image.currentURI;
    if (imgURI.schemeIs("javascript"))
      return false;

    var img = document.createElementNS(kXUL_NS, "image");
    img.setAttribute("src", imgURI.spec);
    return img;
  },

  _stretchImage: function ()
  {
    var img = this._createImage();
    img.width = this._monitor.boxObject.width;
    img.height = this._monitor.boxObject.height;
    this._monitor.appendChild(img);
  },

  _tileImage: function ()
  {
    var canvas = document.createElementNS(kHTML_NS, "canvas");
    var width = this._monitor.boxObject.width;
    var height = this._monitor.boxObject.height;
    canvas.width = width;
    canvas.height = height;

    var tileWidth = Math.floor(this._image.naturalWidth * width / screen.width);
    var tileHeight = Math.floor(this._image.naturalHeight * height / screen.height);
    var ctx = canvas.getContext("2d");
    for (var x = 0; x < width; x += tileWidth) {
      for (var y = 0; y < height; y += tileHeight) {
        ctx.drawImage(this._image, x, y, tileWidth, tileHeight);
      }
    }

    this._monitor.appendChild(canvas);
  },

  _centerImage: function ()
  {
    var img = this._createImage();
    // Use naturalHeight/Width here so we don't scale an image improperly in
    // the preview window if the image is resized in the browser window.
    var width = this._image.naturalWidth * this._monitor.boxObject.width / screen.width;
    var height = this._image.naturalHeight * this._monitor.boxObject.height / screen.height;
    img.width = Math.floor(width);
    img.height = Math.floor(height);
    this._monitor.appendChild(img);
  }
};
